%define	name	device-mapper
%define	version	1.02.09
%define	extraversion	%{nil}
%define	release	%mkrel 1

%ifarch %{ix86} x86_64 ppc ppc64 %{sunsparc}
%define	use_dietlibc	1
%else
%define	use_dietlibc	0
%endif

%define	build_dmeventd 1

%{?_with_dmeventd: %{expand: %%global build_dmeventd 1}}
%{?_without_dmeventd: %{expand: %%global build_dmeventd 0}}
%{?_with_dietlibc: %{expand: %%global use_dietlibc 1}}
%{?_without_dietlibc: %{expand: %%global use_dietlibc 0}}

%define	_sbindir	/sbin
%define	major	1.02

# Macro: %%{mklibname <name> [<major> [<minor>]] [-s] [-d]}
%define	libname	%mklibname devmapper %major
%define	dlibname	%mklibname devmapper %major -d
%define	pdlibname	%mklibname devmapper -d
%define	elibname	%mklibname devmapper-event %major
%define	delibname	%mklibname devmapper-event %major -d
%define	pdelibname	%mklibname devmapper-event -d

Summary:	Device mapper
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	ftp://sources.redhat.com/pub/dm/%{name}.%{version}%{extraversion}.tar.bz2
Patch0:		device-mapper.1.02.07-build.patch
Patch2:		device-mapper.1.02.07-pk.patch
Patch3:		device-mapper.1.02.09-misc.patch
License:	GPL
Group:		System/Kernel and hardware
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://sources.redhat.com/dm/
BuildRequires:	autoconf2.5 >= 2.53
%if %{use_dietlibc}
BuildRequires:	dietlibc-devel
%else
BuildRequires:	glibc-static-devel
%endif

%description
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

%package -n	dmsetup
Summary:	Device mapper setup tool
Group:		System/Kernel and hardware
Provides:	device-mapper = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}

%description -n	dmsetup
Dmsetup manages logical devices that use the device-mapper driver.  
Devices are created by loading a table that specifies a target for
each sector (512 bytes) in the logical device.

%package -n	%{libname}
Summary:	Device mapper library
Group:		System/Kernel and hardware
#Requires(post,postun):	ldconfig

%description -n	%{libname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the shared libraries required for running
programs which use device-mapper.

%package -n	%{dlibname}
Summary:	Device mapper development library
Group:		Development/C
Provides:	device-mapper-devel = %{version}-%{release}
Provides:	libdevmapper-devel = %{version}-%{release}
Provides:	%{pdlibname} = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-devel < %{version}-%{release}

%description -n	%{dlibname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the header files and development libraries
for building programs which use device-mapper.

%if %{build_dmeventd}
%package -n	%{elibname}
Summary:	Device mapper event library
Group:		System/Kernel and hardware
#Requires(post,postun):	ldconfig

%description -n	%{elibname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the shared libraries required for running
programs which use device-mapper-event.

%package -n	%{delibname}
Summary:	Device mapper event development library
Group:		Development/C
Provides:	device-mapper-event-devel = %{version}-%{release}
Provides:	libdevmapper-event-devel = %{version}-%{release}
Provides:	%{pdelibname} = %{version}-%{release}
Requires:	%{elibname} = %{version}-%{release}
Requires:	%{dlibname} = %{version}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-event-devel < %{version}-%{release}

%description -n	%{delibname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the header files and development libraries
for building programs which use device-mapper-event.
%endif

%prep
%setup -q -n %{name}.%{version}%{extraversion}
%patch0 -p1 -b .build
%patch2 -p1 -b .pkg
%patch3 -p1 -b .misc
autoconf

%build
%configure2_5x --with-user=`id -un` --with-group=`id -gn` \
%if %{use_dietlibc}
	--enable-static_link_dietlibc \
%else
	--enable-static_link \
%endif
	--disable-selinux \
%if %{build_dmeventd}
	--enable-dmeventd \
%endif
	--enable-pkgconfig \

%make

%install
rm -rf %{buildroot}
%makeinstall
mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libdevmapper.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/libdevmapper.so.%{major} %{buildroot}%{_libdir}/libdevmapper.so
%if %{use_dietlibc}
mv $RPM_BUILD_ROOT%{_sbindir}/dmsetup-static{-diet,}
%endif
chmod -R u+w %{buildroot} #else brp won't strip binaries

%clean
rm -rf %{buildroot}

%files -n dmsetup
%defattr(644,root,root,755)
%doc INSTALL INTRO README VERSION WHATS_NEW
#doc patches/*.patch.bz2
%doc scripts/*
%doc contrib/*
%attr(755,root,root) %{_sbindir}/dmsetup
%attr(755,root,root) %{_sbindir}/dmsetup-static
%{_mandir}/man8/dmsetup.8*

%files -n %{libname}
%defattr(755,root,root)
/%{_lib}/libdevmapper.so.*

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files -n %{dlibname}
%defattr(644,root,root,755)
%{_libdir}/libdevmapper.so
%{_libdir}/libdevmapper.a*
%{_includedir}/libdevmapper.h
%if %{use_dietlibc}
%{_libdir}/libdevmapper-diet.a*
%endif
%{_libdir}/pkgconfig/devmapper.pc

%if %{build_dmeventd}
%defattr(755,root,root)
%files -n %{elibname}
%{_libdir}/libdevmapper-event.so.*

%post -n %{elibname} -p /sbin/ldconfig
%postun -n %{elibname} -p /sbin/ldconfig

%files -n %{delibname}
%defattr(644,root,root,755)
%{_includedir}/libdevmapper-event.h
%{_libdir}/libdevmapper-event.so
%{_libdir}/libdevmapper-event.a*
%{_libdir}/pkgconfig/devmapper-event.pc
%endif

%changelog
* Sun Aug 27 2006 Luca Berra <bluca@comedia.it>
+ 2006-08-27 04:59:04 (58202)
New release 1.02.09

* Wed Jul 05 2006 Luca Berra <bluca@comedia.it>
+ 2006-07-05 09:11:23 (38379)
import device-mapper-1.02.07-4mdv2007.0

* Sun May 28 2006 Luca Berra <bluca@vodka.it> 1.02.07-4mdv2007.0
- merge p1 into p0
	- fix building of shared library
	- fix debug build
	- remove .diet.o and .pic.o files in clean target
- enable dmeventd

* Tue May 23 2006 Luca Berra <bluca@vodka.it> 1.02.07-3mdk
- s/Obsolete/Conflict/

* Sun May 21 2006 Luca Berra <bluca@vodka.it> 1.02.07-2mdk
- Obsolete previous versions of development packages

* Sun May 21 2006 Luca Berra <bluca@vodka.it> 1.02.07-1mdk
- release 1.02.07
- add -lcompat to device mapper build (for getline)
- always install static library
- fix pkgconfig file location
- remove selinux libraries from pkgconfig files

* Sat May 06 2006 Luca Berra <bluca@vodka.it> 1.02.05-1mdk
- New release 1.02.05
- update diet patch
- add ppc64 to dietlibc arches
- allow overriding of dietlibc build
- optional build of dmeventd (disabled by default)
- require(pre,post) ldconfig
- do not include patches for old kernels in %doc

* Thu Apr 20 2006 Per yvind Karlsen <pkarlsen@mandriva.com> 1.01.05-2mdk
- build against dietlibc on sparc
- %mkrel

* Sat Jan 21 2006 Luca Berra <bluca@vodka.it> 1.01.05-1mdk
- New release 1.01.05
- update patches

* Sat Dec 31 2005 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.01.00-3mdk
- Rebuild

* Sat Mar 05 2005 Luca Berra <bluca@vodka.it> 1.01.00-2mdk 
- use the correct major number

* Fri Mar 04 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.01.00-1mdk
- new release

* Fri Jan 14 2005 Per yvind Karlsen <peroyvind@linux-mandrake.com> 1.00.21-1mdk
- 1.00.21

* Sun Oct 03 2004 Luca Berra <bluca@vodka.it> 1.00.19-4mdk 
- rework package descriptions

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.00.19-3mdk
- only build DSOs with PIC
- rewrite dietlibc patch for a one-shot build

* Sun Aug 01 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.00.19-2mdk
- enable dietlibc version on ppc

* Mon Jul 26 2004 Luca Berra <bluca@vodka.it> 1.00.19-1mdk 
- 1.00.19
- rediffed p0
- disable selinux build

* Tue Jun 29 2004 Luca Berra <bluca@vodka.it> 1.00.18-1mdk 
- 1.00.18
- rediffed p0
- fix unstripped binaries

* Mon Apr 19 2004 Per yvind Karlsen <peroyvind@linux-mandrake.com> 1.00.16-2mdk
- fix buildrequires
- spec cosmetics

* Sat Apr 17 2004 Luca Berra <bluca@vodka.it> 1.00.16-1mdk 
- 1.00.16
- rediffed p0
- added dmsetup-static

* Fri Dec 19 2003 Luca Berra <bluca@vodka.it> 1.00.07-2mdk
- i discovered --disable-compat to configure actually enables it
- put library in %{_lib}
- fix permissions

* Sat Nov 22 2003 Luca Berra <bluca@vodka.it> 1.00.07-1mdk
- 1.00.07
- dmsetup requires same version of library
- correct provides for development library

* Thu Nov 20 2003 Luca Berra <bluca@vodka.it> 1.00.05-2mdk
- provide dietlibc version for building lvm2 tools

* Sat Sep 06 2003 Luca Berra <bluca@vodka.it> 1.00.05-1mdk
- 1.00.05

* Wed Aug 27 2003 Luca Berra <bluca@vodka.it> 1.00.01-0.rc2.1mdk
- 1.00.04
- mdk uses bz2

* Wed Jul 16 2003 Luca Berra <bluca@vodka.it> 1.00.01-0.rc2.1mdk
- 1.00.01-rc2

